VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "Component"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'
' ComponentType DataWrapper
'
' Author: Shelley Powers
'
' Data wrapper that handles all updates and queries to ComponentType database table
'=============================================================================

Implements ObjectControl

' Connection String
Private m_connString

' ObjectControl Methods
Private Sub ObjectControl_Activate()
' using OLE DB to access SQL Server version of database
'm_connString = "Provider=SQLOLEDB;server=FLAME;database=weaver;uid=sa;pwd="

' using ODBC to access Access 2000 database
m_connString = "DSN=weaver;uid=sa;pwd="

End Sub

Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
 ' no activity
End Sub

' Wrapper functions
'=============================================================================
'
' query Functions
'
Function getTypes() As Recordset

Dim cn As New Connection
Dim rs As New Recordset

On Error GoTo ErrorHandler

' set and open connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' perform database operation
Set rs.ActiveConnection = cn
rs.Source = "select cd, description from ComponentType"

rs.Open

Set rs.ActiveConnection = Nothing
cn.Close

Set getTypes = rs

Exit Function

ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Accessing ComponentTypes: " & Err.Description

End Function


Function getTypeCodes() As Variant
Dim cn As New Connection
Dim rs As New Recordset
Dim varCodes() As String
Dim i, iCount As Integer

On Error GoTo ErrorHandler

' set and open connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' perform database operation
Set rs.ActiveConnection = cn
rs.Source = "select cd from ComponentType"

rs.Open

iCount = rs.RecordCount
For i = 0 To iCount
   varCodes(i) = rs.Fields(i)
Next

getTypeCodes = varCodes

Exit Function

ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Accessing ComponentType Desc: " & Err.Description

End Function

' get Component type description
Function getTypeDesc(ByVal strCode As String) As String

Dim cn As New Connection
Dim rs As New Recordset
Dim strDesc As String

On Error GoTo ErrorHandler

' set and open connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' perform database operation
Set rs.ActiveConnection = cn
rs.Source = "select description from ComponentType where cd = '" & _
                    UCase(strCode) & "'"

rs.Open

If rs.RecordCount > 0 Then
   strDesc = rs("description")
End If

getTypeDesc = strDesc

Exit Function

ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Accessing ComponentType Desc: " & Err.Description

End Function

'
' update methods
'

' insert ComponentType record
Sub setType(ByVal strCode As String, ByVal strDesc As String)

Dim cn As New Connection
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()

' set and open connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' perform database operation
cn.Execute "insert into ComponentType values('" & _
           UCase(strCode) & "','" & strDesc & "')"

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Accessing ComponentType Desc: " & Err.Description

End Sub

' delete ComponentType record
Sub destroyType(ByVal strCode As String)

Dim cn As New Connection
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()

' set and open connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' perform database operation
cn.Execute "delete from ComponentType where cd = '" & UCase(strCode) & "'"

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Accessing ComponentType Desc: " & Err.Description

End Sub



' update type description
Sub updateType(ByVal strCode As String, ByVal strDesc As String)

Dim cn As New Connection
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()

' set and open connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' perform database operation
cn.Execute "update ComponentType set description = '" & strDesc & _
           "' where cd = '" & strCode & "'"

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Updating XmlAuxType: " & Err.Description

End Sub

