VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "StylePage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'
' Directory
'
' Author: Shelley Powers
'
' Data objects to maintain Web Weaver Pages
'=============================================================================

Implements ObjectControl

' Connection String
Private m_connString

' ObjectControl Methods
Private Sub ObjectControl_Activate()

' using OLE DB to access SQL Server version of database
'm_connString = "Provider=SQLOLEDB;server=FLAME;database=weaver;uid=sa;pwd="

' using ODBC to access Access 2000 database
m_connString = "DSN=weaver;uid=sa;pwd="

End Sub

Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
 ' no activity
End Sub

'
'================================================================================
' Data Object Methods


' create page
Sub createStylePage(ByVal varIdentifier As Variant, _
                    ByVal strName As String, _
                    ByVal strFile As String, _
                    ByVal strExt As String, _
                    ByVal varDirectoryId As Variant, _
                    ByVal strPageType As String, _
                    ByVal varFileSize As Variant, _
                    ByVal varToolId As Variant, _
                    ByVal varVerificationDt As Variant, _
                    ByVal varPulledDt As Variant, _
                    ByVal strVersion As String, _
                    ByVal strStyleCd As String)

Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString

cn.Open

' possible null values
If Len(varVerificationDt) = 0 Then
   varVerificationDt = "null"
Else
   varVerificationDt = "'" & varVerificationDt & "'"
End If
If Len(varToolId) = 0 Then
   varToolId = "null"
End If
If Len(varPulledDt) = 0 Then
   varPulledDt = "null"
Else
   varPulledDt = "'" & varPulledDt & "'"
End If


' truncate strings if necessary
strName = UCase(Left(strName, 20))
strFile = Left(strFile, 20)
strVersion = Left(strVersion, 20)

' build insert
Dim str As String
str = "insert into WebPage (id, name, filename, ext, directory_id, " & _
           "page_type_cd, file_size, verification_tool_id, verification_date, " & _
           "pulled_date)" & _
           " values(" & varIdentifier & ",'" & strName & "','" & _
           strFile & "','" & UCase(strExt) & "'," & varDirectoryId & _
           ",'" & strPageType & "'," & varFileSize & "," & varToolId & "," & _
           varVerificationDt & "," & varPulledDt & ")"
      
' execute sql
cn.Execute str

' associated table insert
str = "insert into StyleWebPage (webpage_id, style_version, style_code) " & _
      "values(" & varIdentifier & ", '" & strVersion & "','" & _
      strStyleCd & "')"

cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, str & "Creating Page: " & Err.Description

End Sub



' update media object
Sub updateStylePage(ByVal varIdentifier As Variant, _
                    ByVal strName As String, _
                    ByVal strFile As String, _
                    ByVal strExt As String, _
                    ByVal varDirectoryId As Variant, _
                    ByVal strPageType As String, _
                    ByVal varFileSize As Variant, _
                    ByVal varToolId As Variant, _
                    ByVal varVerificationDt As Variant, _
                    ByVal varPulledDt As Variant, _
                    ByVal strVersion As String, _
                    ByVal strStyleCd As String)
                     
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

' possible null values
If Len(varVerificationDt) = 0 Then
   varVerificationDt = "null"
Else
   varVerificationDt = "'" & varVerificationDt & "'"
End If
If Len(varToolId) = 0 Then
   varToolId = "null"
End If
If Len(varPulledDt) = 0 Then
   varPulledDt = "null"
Else
   varPulledDt = "'" & varPulledDt & "'"
End If


' truncate strings if necessary
strName = UCase(Left(strName, 20))
strFile = Left(strFile, 20)
strVersion = Left(strVersion, 20)

' create command
Dim comnd As New Command
Set comnd.ActiveConnection = cn
comnd.CommandType = adCmdText

' build update
Dim str As String
str = "update WebPage set " _
      & "name = '" & strName & "', " _
      & "filename = '" & strFile & "', " _
      & "ext = '" & UCase(strExt) & "', " _
      & "directory_id = " & varDirectoryId & ", " _
      & "file_size = " & varFileSize & ", " _
      & "verification_tool_id = " & varToolId & ", " _
      & "verification_date = " & varVerificationDt & ", " _
      & "pulled_date = " & varPulledDt _
      & " where id = " & varIdentifier
      
comnd.CommandText = str

comnd.Execute

str = "update StyleWebPage set " _
      & "style_version = '" & strVersion & "'," _
      & "style_code = '" & strStyleCd & "'" & _
         " where webpage_id = " & varIdentifier
         
comnd.CommandText = str
comnd.Execute

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Updating Page: " & Err.Description

End Sub




' delete specific page
Sub deletePage(ByVal varPageId As Variant)
                     
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString

cn.Open

' build deletion
Dim str As String
str = "delete from StyleWebPage where webpage_id = " & varPageId

' execute sql
cn.Execute str

str = "delete from WebPage where id = " & varPageId
cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Deleting Page: " & Err.Description

End Sub


' return partial records for all pages
Function getPartialPages() As ADODB.Recordset

' open connection
Dim cn As New Connection
Dim rs As New Recordset

On Error GoTo ErrorHandler

cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Mode = adModeRead
cn.Open

rs.CursorLocation = adUseClient

' query for Pages
Dim str As String
str = "select a.id, a.name, filename, b.id, b.name " & _
      "from WebPage a, Directory b where a.directory_id = b.id " & _
      " and page_type_cd = 'STY'" & _
      " order by 3, 2"
rs.Open str, cn, adOpenForwardOnly, adLockReadOnly

Set rs.ActiveConnection = Nothing
cn.Close

Set getPartialPages = rs

Exit Function
ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Retrieving Partial Page: " & Err.Description

End Function


' return specific item
Function getPage(ByVal varComponentId As Variant) As ADODB.Recordset

Dim cn As New Connection
Dim rs As New Recordset

On Error GoTo ErrorHandler

' open connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' query for component
 Set rs.ActiveConnection = cn

' run query
Dim str As String
rs.Source = "select * from WebPage, StyleWebPage  where " & _
            "webpage_id = id and id = " & CStr(varComponentId)
rs.Open

' disconnect recordset
Set rs.ActiveConnection = Nothing
cn.Close

Set getPage = rs
Exit Function

ErrorHandler:

   Err.Raise Err.Number, Err.Source, errstr & "Retrieving Page: " & Err.Description

End Function








