VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "WbPage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'
' Directory
'
' Author: Shelley Powers
'
' Data objects to maintain object associations
'=============================================================================

Implements ObjectControl

' Connection String
Private m_connString

' ObjectControl Methods
Private Sub ObjectControl_Activate()

' using OLE DB to access SQL Server version of database
'm_connString = "Provider=SQLOLEDB;server=FLAME;database=weaver;uid=sa;pwd="

' using ODBC to access Access 2000 database
m_connString = "DSN=weaver;uid=sa;pwd="

End Sub

Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
 ' no activity
End Sub

'
'================================================================================
' Data Object Methods

Function getPages() As Recordset
On Error GoTo ErrorHandler
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' create recordset
Dim rs As New Recordset
Set rs.ActiveConnection = cn

Dim str
str = "select id, page_type_cd, name, filename from WebPage " & _
      " order by name"
rs.Source = str
rs.CursorLocation = adUseClient

rs.Open

Set rs.ActiveConnection = Nothing

cn.Close

Set getPages = rs

Exit Function

ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Getting WebPages: " & Err.Description

End Function

'======================================================
' PageScript
'======================================================

Sub setPageScriptAssoc(ByVal varPageId As Variant, _
                 ByVal varScriptId As Variant)
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

Dim str As String

str = "insert into PageScript" & _
           " values(" & varPageId & "," & varScriptId & ")"

cn.Execute str
cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, str & "Creating Page Assoc: " & Err.Description

End Sub

Sub deletePageScriptAssoc(ByVal varPageId As Variant, _
                          ByVal varScriptId As Variant)
                          
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

Dim str
str = "delete from PageScript where " & _
      "page_id = " & varPageId & _
      "and script_page_id = " & varScriptId

cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Deleting Page Assocation: " & Err.Description

End Sub

Function showPageScriptAssocs() As ADODB.Recordset

On Error GoTo ErrorHandler
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' create recordset
Dim rs As New Recordset
Set rs.ActiveConnection = cn

Dim str
str = "select a.id, a.name, a.filename, b.id, b.name, b.filename from " & _
      "WebPage a, WebPage b, PageScript where " & _
      "a.id = page_id and b.id = script_page_id order by 2, 5"
rs.Source = str

rs.Open

Set rs.ActiveConnection = Nothing

cn.Close

Set showPageScriptAssocs = rs

Exit Function

ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Getting Page Associations: " & Err.Description
End Function


'======================================================
' PageComponent
'======================================================

Sub setPageCompAssoc(ByVal varPageId As Variant, _
                 ByVal varComponentId As Variant)
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

Dim str As String

str = "insert into PageComponent" & _
           " values(" & varPageId & "," & varComponentId & ")"

cn.Execute str
cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, str & "Creating Page Assoc: " & Err.Description

End Sub

Sub deletePageCompAssoc(ByVal varPageId As Variant, _
                          ByVal varComponentId As Variant)
                          
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

Dim str
str = "delete from PageComponent where " & _
      "page_id = " & varPageId & _
      "and component_id = " & varComponentId

cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Deleting Page Assocation: " & Err.Description

End Sub

Function showPageCompAssocs() As ADODB.Recordset

On Error GoTo ErrorHandler
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' create recordset
Dim rs As New Recordset
Set rs.ActiveConnection = cn

Dim str
str = "select a.id, a.name, a.filename, b.id, b.name, b.filename from " & _
      "WebPage a, Component b, PageComponent where " & _
      "a.id = page_id and b.id = component_id order by 2, 5"
rs.Source = str

rs.Open

Set rs.ActiveConnection = Nothing

cn.Close

Set showPageCompAssocs = rs

Exit Function

ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Getting Page Associations: " & Err.Description
End Function


'======================================================
' PageStyle
'======================================================

Sub setPageStyleAssoc(ByVal varPageId As Variant, _
                 ByVal varStyleId As Variant)
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

Dim str As String

str = "insert into PageStyle" & _
           " values(" & varPageId & "," & varStyleId & ")"

cn.Execute str
cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, str & "Creating Page Assoc: " & Err.Description

End Sub

Sub deletePageStyleAssoc(ByVal varPageId As Variant, _
                          ByVal varStyleId As Variant)
                          
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

Dim str
str = "delete from PageStyle where " & _
      "page_id = " & varPageId & _
      "and style_page_id = " & varStyleId

cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Deleting Page Assocation: " & Err.Description

End Sub

Function showPageStyleAssocs() As ADODB.Recordset

On Error GoTo ErrorHandler
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' create recordset
Dim rs As New Recordset
Set rs.ActiveConnection = cn

Dim str
str = "select a.id, a.name, a.filename, b.id, b.name, b.filename from " & _
      "WebPage a, WebPage b, PageStyle where " & _
      "a.id = page_id and b.id = style_page_id order by 2, 5"
rs.Source = str

rs.Open

Set rs.ActiveConnection = Nothing

cn.Close

Set showPageStyleAssocs = rs

Exit Function

ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Getting Page Associations: " & Err.Description
End Function


'======================================================
' PageXmlAux
'======================================================

Sub setPageAuxAssoc(ByVal varPageId As Variant, _
                 ByVal varAuxId As Variant)
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

Dim str As String

str = "insert into PageXmlAux" & _
           " values(" & varPageId & "," & varAuxId & ")"

cn.Execute str
cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, str & "Creating Page Assoc: " & Err.Description

End Sub

Sub deletePageAuxAssoc(ByVal varPageId As Variant, _
                          ByVal varAuxId As Variant)
                          
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

Dim str
str = "delete from PageXmlAux where " & _
      "page_id = " & varPageId & _
      " and xml_aux_id = " & varAuxId

cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, str & "Deleting Page Assocation: " & Err.Description

End Sub

Function showPageAuxAssocs() As ADODB.Recordset

On Error GoTo ErrorHandler
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' create recordset
Dim rs As New Recordset
Set rs.ActiveConnection = cn

Dim str
str = "select a.id, a.name, a.filename, b.id, b.name, b.filename from " & _
      "WebPage a, WebPage b, PageXmlAux where " & _
      "a.id = page_id and b.id = xml_aux_id order by 2, 5"
rs.Source = str

rs.Open

Set rs.ActiveConnection = Nothing

cn.Close

Set showPageAuxAssocs = rs

Exit Function

ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Getting Page Associations: " & Err.Description
End Function



'======================================================
' PageMedia
'======================================================

Sub setPageMediaAssoc(ByVal varPageId As Variant, _
                 ByVal varMediaId As Variant)
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

Dim str As String

str = "insert into PageMedia" & _
           " values(" & varPageId & "," & varMediaId & ")"

cn.Execute str
cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, str & "Creating Page Assoc: " & Err.Description

End Sub

Sub deletePageMediaAssoc(ByVal varPageId As Variant, _
                          ByVal varMediaId As Variant)
                          
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

Dim str
str = "delete from PageMedia where " & _
      "page_id = " & varPageId & _
      "and media_id = " & varMediaId

cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Deleting Page Assocation: " & Err.Description

End Sub

Function showPageMediaAssocs() As ADODB.Recordset

On Error GoTo ErrorHandler
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' create recordset
Dim rs As New Recordset
Set rs.ActiveConnection = cn

Dim str
str = "select a.id, a.name, a.filename, b.id, b.name, b.filename from " & _
      "WebPage a, MediaObject b, PageMedia where " & _
      "a.id = page_id and b.id = media_id order by 2, 5"
rs.Source = str

rs.Open

Set rs.ActiveConnection = Nothing

cn.Close

Set showPageMediaAssocs = rs

Exit Function

ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Getting Page Associations: " & Err.Description
End Function


