// page.cpp : Implementation of Cpage
#include "stdafx.h"
#include "Asp1502.h"
#include "page.h"

#import "C:\Program Files\Common Files\System\ADO\msado15.dll" \
    no_namespace rename("EOF", "EndOfFile")

#include <stdio.h>
#include <share.h>
#include "CTypeTable.h"


/////////////////////////////////////////////////////////////////////////////
// Cpage
HRESULT Cpage::Activate()
{
   HRESULT hr = S_OK;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // get ObjectContext
   hr = CoGetObjectContext(IID_IObjectContext, (void **)&m_spObjectContext);
   if (FAILED(hr)) return hr;
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) return hr;

   // get Response property
   hr = pProps->GetProperty( _bstr_t("Response"), &vt ) ;
   if (FAILED(hr)) return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );
   if (FAILED(hr)) return hr;

   // get connection string
   CComPtr<IApplicationObject> pApplication;

   hr = pProps->GetProperty(_bstr_t("Application"),&vt);
   if (FAILED(hr)) return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IApplicationObject, 
                     (void**)&pApplication );
   if (FAILED(hr)) return hr;
  
   CComVariant vtConn;
   CComBSTR bstrName("connection");
   hr = pApplication->get_Value(bstrName,&vtConn);
   
   if (FAILED(hr)) return hr;

   m_bstrConnection = vtConn;

   return S_OK;
} 

BOOL Cpage::CanBePooled()
{
	return TRUE;
} 

void Cpage::Deactivate()
{
    m_piResponse.Release();
	m_spObjectContext.Release();
} 


STDMETHODIMP Cpage::createRecordset()
{
  _RecordsetPtr pRecordset = NULL;
  _ConnectionPtr pConn = NULL;

  // test to see if file exists
  // if it does, exit method
  FILE *stream;

  if( (stream = _fsopen( "c:\\datasets\\set.adtg", "rt", _SH_DENYWR )) != NULL ) {
      fclose(stream);
      return S_OK;
  }

  try {
    pConn.CreateInstance(__uuidof(Connection));
    pRecordset.CreateInstance(__uuidof(Recordset));

    // open connection
    pConn->Open(m_bstrConnection,"","",NULL);

    // open recordset
    _bstr_t bstrSource = "select WebPage.name, filename, page_type_cd, " +
                         _bstr_t("web_location from WebPage, Directory ") +
                         _bstr_t("where directory_id = Directory.id");
    
    pRecordset->PutCursorLocation(adUseClient);
    pRecordset->Open(_variant_t(bstrSource),pConn.GetInterfacePtr(),
                     adOpenForwardOnly, adLockReadOnly,adCmdText);

    // disconnect recordset
    pRecordset->PutRefActiveConnection(NULL);   

    // close connection
    pConn->Close();

    // save to file
    pRecordset->Save(_variant_t("c:\\datasets\\set.adtg"),adPersistADTG);
    pRecordset->Close();

  }
  catch (_com_error e) {
      m_piResponse->Write(_variant_t(e.Description()));
  }

  return S_OK;
}

STDMETHODIMP Cpage::showPage(int iPageSize, int iCurrentPage, int* iPageCount)
{
  _RecordsetPtr pRecordset = NULL;

  try {
    pRecordset.CreateInstance(__uuidof(Recordset));

    // open recordset
    pRecordset->Open(OLESTR("c:\\datasets\\set.adtg"),vtMissing, 
                     adOpenForwardOnly, adLockReadOnly,adCmdUnknown);
                 
    // adjust paging
    pRecordset->PutPageSize(iPageSize);
    pRecordset->PutAbsolutePage((PositionEnum)iCurrentPage);

    int iCt = 1;

    // cycle through page accessing rows
    while(iCt <= iPageSize) {
      m_piResponse->Write(_variant_t("<p><a href='http://"));
      m_piResponse->Write(pRecordset->Fields->GetItem(_variant_t("web_location"))->GetValue());
      m_piResponse->Write(_variant_t("/"));
      m_piResponse->Write(pRecordset->Fields->GetItem(_variant_t("filename"))->GetValue());
      m_piResponse->Write(_variant_t("'>"));
      m_piResponse->Write(pRecordset->Fields->GetItem(_variant_t("name"))->GetValue());
      m_piResponse->Write(_variant_t("</a></p>"));

      pRecordset->MoveNext();
      iCt++;
      if (pRecordset->EndOfFile)
          iCt = iPageSize + 1;
    } 

    // return count of pages
    *iPageCount = pRecordset->GetPageCount();

    // close
    pRecordset->Close();

  }
  catch (_com_error e) {
      m_piResponse->Write(_variant_t(e.Description()));
  }

  return S_OK;

}

STDMETHODIMP Cpage::showSpecificPage(int iPageSize, int iCurrentPage, int *iPageCount)
{
  _RecordsetPtr pRecordset = NULL;

  try {
    pRecordset.CreateInstance(__uuidof(Recordset));

    // open recordset
    pRecordset->Open(_variant_t("c:\\datasets\\set.adtg"),vtMissing, 
                     adOpenForwardOnly, adLockReadOnly,adCmdUnknown);
                              
    // set sort and filter
    pRecordset->PutFilter(OLESTR("page_type_cd = 'HTM' or page_type_cd = 'APP' or page_type_cd = 'XML'"));
    pRecordset->PutSort(L"name ASC");
    pRecordset->PutPageSize(iPageSize);
    pRecordset->PutAbsolutePage((PositionEnum)iCurrentPage);

    int iCt = 1;

    // cycle through page processing rows
    while(iCt <= iPageSize) {
      m_piResponse->Write(_variant_t("<p><a href='http://"));
      m_piResponse->Write(pRecordset->Fields->GetItem(_variant_t("web_location"))->GetValue());
      m_piResponse->Write(_variant_t("/"));
      m_piResponse->Write(pRecordset->Fields->GetItem(_variant_t("filename"))->GetValue());
      m_piResponse->Write(_variant_t("'>"));
      m_piResponse->Write(pRecordset->Fields->GetItem(_variant_t("name"))->GetValue());
      m_piResponse->Write(_variant_t("</a></p>"));

      pRecordset->MoveNext();
      iCt++;
      if (pRecordset->EndOfFile)
          iCt = iPageSize + 1;
    } 

    // return page count
    *iPageCount = pRecordset->GetPageCount();

    // close
    pRecordset->Close();

  }
  catch (_com_error e) {
      m_piResponse->Write(_variant_t(e.Description()));
  }

  return S_OK;
}

STDMETHODIMP Cpage::showTypes(BSTR bstrTableName)
{
  _RecordsetPtr pRecordset = NULL;
  IADORecordBinding   *typeRs = NULL;  
  CTypeTable tble;

  try {
    pRecordset.CreateInstance(__uuidof(Recordset));

    // open recordset
    pRecordset->Open(bstrTableName,m_bstrConnection, 
                     adOpenForwardOnly, adLockReadOnly,adCmdTable);

    pRecordset->QueryInterface(__uuidof(IADORecordBinding),(LPVOID*)&typeRs);

    typeRs->BindToRecordset(&tble);

    // process rows
    while(!(pRecordset->EndOfFile)) {
        m_piResponse->Write(_variant_t(tble.m_code));
        m_piResponse->Write(_variant_t(" = "));
        m_piResponse->Write(_variant_t(tble.m_description));
        m_piResponse->Write(_variant_t("<br>"));
      
        pRecordset->MoveNext();
    } 

    // close
    pRecordset->Close();

    // release binding
    typeRs->Release();

  }
  catch (_com_error e) {
      m_piResponse->Write(_variant_t(e.Description()));
  }

  return S_OK;
}
