// group.cpp : Implementation of Cgroup
#include "stdafx.h"
#include "Asp1702.h"
#include "group.h"

/////////////////////////////////////////////////////////////////////////////
// Cgroup


STDMETHODIMP Cgroup::createGroup(BSTR bstrGroup)
{
   HRESULT hr = S_OK;
   IADsGroup *pGroup;
   IADsContainer *pContainer;
   IDispatch *pDisp                  = NULL;
   IADs *pADs                        = NULL;
   _variant_t varGroup = bstrGroup;
   _variant_t varType;
   _bstr_t bstrGrp = bstrGroup;

   // change group name to a relative, unique name
   bstrGrp = "CN=" + bstrGrp;

   // get group
   hr = ADsGetObject(L"LDAP://CN=Users,DC=development,DC=local",
                     IID_IADsContainer,
                     (void **) &pContainer);
   if (FAILED(hr))
       return hr;

   // create group object
   hr = pContainer->Create(L"group",bstrGrp,&pDisp);
   if (FAILED(hr))
       return hr;   
   pContainer->Release();

   hr = pDisp->QueryInterface(IID_IADsGroup,(void **)&pGroup);
   if (FAILED(hr))
       return hr;
   pDisp->Release();

   // assign group properties
   pGroup->Put(L"cn",varGroup);
   pGroup->Put(L"sAMAccountName",varGroup);
  

   varType.lVal = ADS_GROUP_TYPE_GLOBAL_GROUP |  ADS_GROUP_TYPE_SECURITY_ENABLED;
   pGroup->Put(L"groupType",varType);

   // save information
   hr=pGroup->SetInfo();

   return hr;
}

// could not use removeGroup
STDMETHODIMP Cgroup::removeGrp(BSTR bstrGroup)
{
   HRESULT hr = S_OK;
   IADsContainer *pContainer;
   _bstr_t bstrGrp = bstrGroup;
   bstrGrp = "CN=" + bstrGrp;

   // get group
   hr = ADsGetObject(L"LDAP://CN=Users,DC=development,DC=local",
                     IID_IADsContainer,
                     (void **) &pContainer);
   if (FAILED(hr))
       return hr;

   // delete group, release container
   pContainer->Delete(L"group",bstrGrp);
   pContainer->Release();

   return hr;
}
